import axios from 'axios'
class Root {
  constructor(_axios) {
    this.moduleName = 'rootModule'
    this.axios = _axios || axios
  }
  filterEmptyValue (obj) {
    if (!obj) return
    const emptyValues = [null, undefined, 'null', 'undefined', NaN]
    for (const k in obj) {
      if (emptyValues.includes(obj[k])) {
        console.log(`数据中有空值${k}`, obj[k])
        delete obj[k]
      } else if (typeof obj[k] === 'object') {
        return this.filterEmptyValue(obj[k])
      }
    }
  }
  get (url, params, headers, config) {
    return this.request('get', url, null, params, headers, config)
  }
  post (url, data, params, headers, config) {
    return this.request('post', url, data, params, headers, config)
  }
  put (url, data, params, headers, config) {
    return this.request('put', url, data, params, headers, config)
  }
  delete (url, data, params, headers, config) {
    return this.request('delete', url, data, params, headers, config)
  }
  requestConfig (config) {
    return axios(config)
  }
  handleParams(params){
    if (params) {
      delete params.token
      delete params._user_info
      delete params.user_info
      const replaceStr = {
        '%': "%25",
        '#': "%23",
        '&': "%26",
        '>': "%3E",
        '<': "%3C",
        '+': "%2B",
        '/': "%2F",
        '=': "3D",
        ':': "3A"
      }
      const replaceStrKeys = Object.keys(replaceStr)
      for (let k in params) {
        let value = params[k]
        replaceStrKeys.forEach(rkey => {
          const reg = new RegExp(`\${rkey}`, 'g')
          value = value.replace(reg, replaceStr[rkey])
        })
        params[k] = value
      }

    }
  }
  request (method, url, data, params, headers = null, config = {}) {
    this.filterEmptyValue(data)
    // 公共头设置
    const aixosCtx = { method, url }
    if (config) {
      Object.assign(aixosCtx, config)
    }
    //this.handleParams(params)
    params && (aixosCtx.params = params)
    if (aixosCtx.params && aixosCtx.params.token) delete aixosCtx.params.token
    if (aixosCtx.params && aixosCtx.params._user_info) delete aixosCtx.params._user_info
    data && (aixosCtx.data = data)
    headers && (aixosCtx.headers = headers)
    const result = this.axios(aixosCtx)
    return result
  }
}

export default Root
